Merge "add onos deployment steps"
[apex.git] / lib / overcloud-deploy-functions.sh
1 #!/usr/bin/env bash
2 ##############################################################################
3 # Copyright (c) 2015 Tim Rozet (Red Hat), Dan Radez (Red Hat) and others.
4 #
5 # All rights reserved. This program and the accompanying materials
6 # are made available under the terms of the Apache License, Version 2.0
7 # which accompanies this distribution, and is available at
8 # http://www.apache.org/licenses/LICENSE-2.0
9 ##############################################################################
10
11 ##preping it for deployment and launch the deploy
12 ##params: none
13 function overcloud_deploy {
14   local num_compute_nodes
15   local num_control_nodes
16   local dpdk_cores pmd_cores socket_mem ovs_dpdk_perf_flag ovs_option_heat_arr
17   declare -A ovs_option_heat_arr
18
19   ovs_option_heat_arr['dpdk_cores']=OvsDpdkCoreList
20   ovs_option_heat_arr['pmd_cores']=PmdCoreList
21   ovs_option_heat_arr['socket_memory']=OvsDpdkSocketMemory
22
23   # OPNFV Default Environment and Network settings
24   DEPLOY_OPTIONS+=" -e ${ENV_FILE}"
25   DEPLOY_OPTIONS+=" -e network-environment.yaml"
26
27   # Custom Deploy Environment Templates
28   if [[ "${#deploy_options_array[@]}" -eq 0 || "${deploy_options_array['sdn_controller']}" == 'opendaylight' ]]; then
29     if [ "${deploy_options_array['sfc']}" == 'True' ]; then
30       DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/opendaylight_sfc.yaml"
31     elif [ "${deploy_options_array['vpn']}" == 'True' ]; then
32       DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/neutron-opendaylight-bgpvpn.yaml"
33       if [ "${deploy_options_array['gluon']}" == 'True' ]; then
34         DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/services/gluon.yaml"
35       fi
36     elif [ "${deploy_options_array['vpp']}" == 'True' ]; then
37       if [ "${deploy_options_array['odl_vpp_netvirt']}" == "True" ]; then
38         DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/neutron-opendaylight-netvirt-vpp.yaml"
39       elif [ "${deploy_options_array['sdn_l3']}" == "True" ]; then
40         DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/neutron-opendaylight-honeycomb.yaml"
41       else
42         DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/neutron-opendaylight-honeycomb-l2.yaml"
43       fi
44     else
45       DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/neutron-opendaylight-l3.yaml"
46     fi
47     SDN_IMAGE=opendaylight
48   elif [ "${deploy_options_array['sdn_controller']}" == 'opendaylight-external' ]; then
49     DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/opendaylight-external.yaml"
50     SDN_IMAGE=opendaylight
51   elif [ "${deploy_options_array['sdn_controller']}" == 'onos' ]; then
52     if [ "${deploy_options_array['sfc']}" == 'True' ]; then
53       DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/neutron-onos-sfc.yaml"
54     else
55       DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/neutron-onos.yaml"
56     fi
57     SDN_IMAGE=onos
58   elif [ "${deploy_options_array['sdn_controller']}" == 'ovn' ]; then
59     if [[ "$ha_enabled" == "True" ]]; then
60       DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/neutron-ml2-ovn-ha.yaml"
61       echo "${red}OVN HA support is not not supported... exiting.${reset}"
62       exit 1
63     else
64       DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/neutron-ml2-ovn.yaml"
65     fi
66     SDN_IMAGE=opendaylight
67   elif [ "${deploy_options_array['sdn_controller']}" == 'opencontrail' ]; then
68     echo -e "${red}ERROR: OpenContrail is currently unsupported...exiting${reset}"
69     exit 1
70   elif [[ -z "${deploy_options_array['sdn_controller']}" || "${deploy_options_array['sdn_controller']}" == 'False' ]]; then
71     echo -e "${blue}INFO: SDN Controller disabled...will deploy nosdn scenario${reset}"
72     if [ "${deploy_options_array['vpp']}" == 'True' ]; then
73       DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/neutron-ml2-vpp.yaml"
74     elif [ "${deploy_options_array['dataplane']}" == 'ovs_dpdk' ]; then
75       DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/neutron-ovs-dpdk.yaml"
76     fi
77     SDN_IMAGE=opendaylight
78   else
79     echo "${red}Invalid sdn_controller: ${deploy_options_array['sdn_controller']}${reset}"
80     echo "${red}Valid choices are opendaylight, opendaylight-external, onos, opencontrail, False, or null${reset}"
81     exit 1
82   fi
83
84   # Enable Tacker
85   if [ "${deploy_options_array['tacker']}" == 'True' ]; then
86     DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/enable_tacker.yaml"
87   fi
88
89   # Enable Congress
90   if [ "${deploy_options_array['congress']}" == 'True' ]; then
91     DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/enable_congress.yaml"
92   fi
93
94   # Enable Real Time Kernel (kvm4nfv)
95   if [ "${deploy_options_array['rt_kvm']}" == 'True' ]; then
96     DEPLOY_OPTIONS+=" -e /home/stack/enable_rt_kvm.yaml"
97   fi
98
99   # Make sure the correct overcloud image is available
100   if [ ! -f $IMAGES/overcloud-full-${SDN_IMAGE}.qcow2 ]; then
101       echo "${red} $IMAGES/overcloud-full-${SDN_IMAGE}.qcow2 is required to execute your deployment."
102       echo "Please install the opnfv-apex package to provide this overcloud image for deployment.${reset}"
103       exit 1
104   fi
105
106   echo "Copying overcloud image to Undercloud"
107   ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" "rm -f overcloud-full.qcow2"
108   scp ${SSH_OPTIONS[@]} $IMAGES/overcloud-full-${SDN_IMAGE}.qcow2 "stack@$UNDERCLOUD":overcloud-full.qcow2
109
110   # disable neutron openvswitch agent from starting
111   if [[ -n "${deploy_options_array['sdn_controller']}" && "${deploy_options_array['sdn_controller']}" != 'False' ]]; then
112       echo -e "${blue}INFO: Disabling neutron-openvswitch-agent from systemd${reset}"
113       ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
114       LIBGUESTFS_BACKEND=direct virt-customize --run-command "rm -f /etc/systemd/system/multi-user.target.wants/neutron-openvswitch-agent.service" \
115                                                --run-command "rm -f /usr/lib/systemd/system/neutron-openvswitch-agent.service" \
116                                                -a overcloud-full.qcow2
117 EOI
118   fi
119
120   if [ "${deploy_options_array['vpn']}" == 'True' ]; then
121       echo -e "${blue}INFO: Enabling ZRPC and Quagga${reset}"
122       ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
123       LIBGUESTFS_BACKEND=direct virt-customize \
124          --run-command "systemctl enable zrpcd" \
125          --run-command "systemctl enable bgpd" \
126          -a overcloud-full.qcow2
127 EOI
128   fi
129
130   # Install ovs-dpdk inside the overcloud image if it is enabled.
131   if [[ "${deploy_options_array['dataplane']}" == 'ovs_dpdk' || "${deploy_options_array['dataplane']}" == 'fdio' ]]; then
132     # install dpdk packages before ovs
133     echo -e "${blue}INFO: Enabling kernel modules for dpdk inside overcloud image${reset}"
134
135     ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
136       cat << EOF > vfio_pci.modules
137 #!/bin/bash
138 exec /sbin/modprobe vfio_pci >/dev/null 2>&1
139 EOF
140
141       cat << EOF > uio_pci_generic.modules
142 #!/bin/bash
143 exec /sbin/modprobe uio_pci_generic >/dev/null 2>&1
144 EOF
145
146       LIBGUESTFS_BACKEND=direct virt-customize --upload vfio_pci.modules:/etc/sysconfig/modules/ \
147                                                --upload uio_pci_generic.modules:/etc/sysconfig/modules/ \
148                                                --run-command "chmod 0755 /etc/sysconfig/modules/vfio_pci.modules" \
149                                                --run-command "chmod 0755 /etc/sysconfig/modules/uio_pci_generic.modules" \
150                                                -a overcloud-full.qcow2
151
152       if [ "${deploy_options_array['dataplane']}" == 'ovs_dpdk' ]; then
153         sed -i "/OS::TripleO::ComputeExtraConfigPre:/c\  OS::TripleO::ComputeExtraConfigPre: ./ovs-dpdk-preconfig.yaml" network-environment.yaml
154       fi
155
156 EOI
157
158   elif [ "${deploy_options_array['dataplane']}" != 'ovs' ]; then
159     echo "${red}${deploy_options_array['dataplane']} not supported${reset}"
160     exit 1
161   fi
162
163   if [ "$debug" == 'TRUE' ]; then
164     ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" "LIBGUESTFS_BACKEND=direct virt-customize -a overcloud-full.qcow2 --root-password password:opnfvapex"
165   fi
166
167   # upgrade ovs into ovs 2.5.90 with NSH function if SFC is enabled
168   if [[ "${deploy_options_array['sfc']}" == 'True' && "${deploy_options_array['dataplane']}" == 'ovs' ]]; then
169     echo "ONOS SFC is currently unavailable. JIRA: APEX-417"
170     exit 1
171     ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
172          LIBGUESTFS_BACKEND=direct virt-customize --run-command "yum install -y /root/ovs/rpm/rpmbuild/RPMS/x86_64/${ovs_kmod_rpm_name}" \
173                                                   --run-command "yum upgrade -y /root/ovs/rpm/rpmbuild/RPMS/x86_64/${ovs_rpm_name}" \
174                                                   -a overcloud-full.qcow2
175 EOI
176   fi
177
178   # Patch neutron with using OVS external interface for router and add generic linux NS interface driver
179   if [[ "${deploy_options_array['dataplane']}" == 'fdio' ]]; then
180     ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
181       LIBGUESTFS_BACKEND=direct virt-customize --run-command "cd /usr/lib/python2.7/site-packages/ && patch -p1 < neutron-patch-NSDriver.patch" \
182                                                -a overcloud-full.qcow2
183 EOI
184
185     # Configure routing node and interface role mapping for odl-fdio
186     if [[ "${deploy_options_array['sdn_l3']}" == 'True' ]]; then
187       ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
188         sed -i "/opendaylight::vpp_routing_node:/c\    opendaylight::vpp_routing_node: ${deploy_options_array['odl_vpp_routing_node']}.${domain_name}" ${ENV_FILE}
189         sed -i "/ControllerExtraConfig:/ c\  ControllerExtraConfig:\n    tripleo::profile::base::neutron::agents::honeycomb::interface_role_mapping:  \"['${tenant_nic_mapping_controller_members}:tenant-interface']\"" ${ENV_FILE}
190         sed -i "/NovaComputeExtraConfig:/ c\  NovaComputeExtraConfig:\n    tripleo::profile::base::neutron::agents::honeycomb::interface_role_mapping:  \"['${tenant_nic_mapping_compute_members}:tenant-interface','${external_nic_mapping_compute_members}:public-interface']\"" ${ENV_FILE}
191 EOI
192     fi
193   fi
194
195   if [ -n "${deploy_options_array['performance']}" ]; then
196     ovs_dpdk_perf_flag="False"
197     for option in "${performance_options[@]}" ; do
198       if [ "${arr[1]}" == "vpp" ]; then
199         if [ "${arr[0]}" == "Compute" ]; then
200           role='NovaCompute'
201         else
202           role=${arr[0]}
203         fi
204         if [ "${arr[2]}" == "main-core" ]; then
205           ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
206             sed -i "/${role}ExtraConfig:/ c\  ${role}ExtraConfig:\n    fdio::vpp_cpu_main_core: \"'${arr[3]}'\"" ${ENV_FILE}
207 EOI
208         elif [ "${arr[2]}" == "corelist-workers" ]; then
209           ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
210             sed -i "/${role}ExtraConfig:/ c\  ${role}ExtraConfig:\n    fdio::vpp_cpu_corelist_workers: \"'${arr[3]}'\"" ${ENV_FILE}
211 EOI
212         fi
213       fi
214       arr=($option)
215       # use compute's kernel settings for all nodes for now.
216       if [ "${arr[0]}" == "Compute" ] && [ "${arr[1]}" == "kernel" ]; then
217         kernel_args+=" ${arr[2]}=${arr[3]}"
218       fi
219       if [ "${arr[0]}" == "Compute" ] && [ "${arr[1]}" == "ovs" ]; then
220          eval "${arr[2]}=${arr[3]}"
221          ovs_dpdk_perf_flag="True"
222       fi
223     done
224
225     ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
226       sed -i "/ComputeKernelArgs:/c\  ComputeKernelArgs: '$kernel_args'" ${ENV_FILE}
227       sed -i "$ a\resource_registry:\n  OS::TripleO::NodeUserData: first-boot.yaml" ${ENV_FILE}
228       sed -i "/NovaSchedulerDefaultFilters:/c\  NovaSchedulerDefaultFilters: 'RamFilter,ComputeFilter,AvailabilityZoneFilter,ComputeCapabilitiesFilter,ImagePropertiesFilter,NUMATopologyFilter'" ${ENV_FILE}
229 EOI
230
231     if [[ "${deploy_options_array['dataplane']}" == 'ovs_dpdk' && "$ovs_dpdk_perf_flag" == "True" ]]; then
232       for ovs_option in ${!ovs_option_heat_arr[@]}; do
233         if [ -n "${!ovs_option}" ]; then
234           ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
235             sed -i "/${ovs_option_heat_arr[$ovs_option]}:/c\  ${ovs_option_heat_arr[$ovs_option]}: ${!ovs_option}" ${ENV_FILE}
236 EOI
237         fi
238       done
239     fi
240   fi
241
242   if [[ -z "${deploy_options_array['sdn_controller']}" || "${deploy_options_array['sdn_controller']}" == 'False' ]]; then
243     if [ "${deploy_options_array['dataplane']}" == "fdio" ]; then
244       if [ "$tenant_nic_mapping_controller_members" == "$tenant_nic_mapping_compute_members" ]; then
245         echo -e "${blue}INFO: nosdn fdio deployment...installing correct vpp packages...${reset}"
246         ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
247           sed -i "/NeutronVPPAgentPhysnets:/c\  NeutronVPPAgentPhysnets: 'datacentre:${tenant_nic_mapping_controller_members}'" ${ENV_FILE}
248 EOI
249       else
250         echo -e "${red}Compute and Controller must use the same tenant nic name, please modify network setting file.${reset}"
251         exit 1
252       fi
253     fi
254   fi
255
256   # Set ODL version accordingly
257   if [[ "${deploy_options_array['sdn_controller']}" == 'opendaylight' && -n "${deploy_options_array['odl_version']}" ]]; then
258     case "${deploy_options_array['odl_version']}" in
259       beryllium) odl_version=''
260               ;;
261       boron)  odl_version='boron'
262               ;;
263       carbon) odl_version='master'
264               ;;
265       *) echo -e "${red}Invalid ODL version ${deploy_options_array['odl_version']}.  Please use 'carbon' or 'boron' values.${reset}"
266          exit 1
267          ;;
268     esac
269
270     ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
271       LIBGUESTFS_BACKEND=direct virt-customize --run-command "yum -y remove opendaylight" \
272                                                --run-command "yum -y install /root/${odl_version}/*" \
273                                                -a overcloud-full.qcow2
274 EOI
275   fi
276
277   # Override ODL if we enable netvirt for fdio
278   if [[ "${deploy_options_array['odl_vpp_netvirt']}" == 'True' && "${deploy_options_array['sdn_controller']}" == 'opendaylight' ]]; then
279     ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
280       LIBGUESTFS_BACKEND=direct virt-customize --run-command "rm -rf /opt/opendaylight/*" \
281                                                --run-command "tar zxvf /root/odl-netvirt-vpp-distribution.tar.gz -C /opt/opendaylight/" \
282                                                -a overcloud-full.qcow2
283 EOI
284   fi
285
286   # check if ceph should be enabled
287   if [ "${deploy_options_array['ceph']}" == 'True' ]; then
288     DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/storage-environment.yaml"
289   fi
290
291   if [ "${deploy_options_array['sdn_controller']}" == 'ovn' ]; then
292     # The epoch in deloran's ovs is 1: and in leif's is 0:
293     # so we have to execute a downgrade instead of an update
294     ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
295       LIBGUESTFS_BACKEND=direct virt-customize \
296         --run-command "cd /root/ovs27 && yum update -y *openvswitch*" \
297         --run-command "cd /root/ovs27 && yum downgrade -y *openvswitch*" \
298         -a overcloud-full.qcow2
299 EOI
300   fi
301
302   # get number of nodes available in inventory
303   num_control_nodes=$(ssh -T ${SSH_OPTIONS[@]} "root@$UNDERCLOUD" "grep -c profile:control /home/stack/instackenv.json")
304   num_compute_nodes=$(ssh -T ${SSH_OPTIONS[@]} "root@$UNDERCLOUD" "grep -c profile:compute /home/stack/instackenv.json")
305
306   # check if HA is enabled
307   if [[ "$ha_enabled" == "True" ]]; then
308     if [ "$num_control_nodes" -lt 3 ]; then
309       echo -e "${red}ERROR: Number of control nodes in inventory is less than 3 and HA is enabled: ${num_control_nodes}. Check your inventory file.${reset}"
310       exit 1
311     else
312      DEPLOY_OPTIONS+=" --control-scale ${num_control_nodes}"
313      DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/puppet-pacemaker.yaml"
314      echo -e "${blue}INFO: Number of control nodes set for deployment: ${num_control_nodes}${reset}"
315     fi
316   else
317     if [ "$num_control_nodes" -lt 1 ]; then
318       echo -e "${red}ERROR: Number of control nodes in inventory is less than 1: ${num_control_nodes}. Check your inventory file.${reset}"
319       exit 1
320     fi
321   fi
322
323   if [ "$num_compute_nodes" -le 0 ]; then
324     echo -e "${red}ERROR: Invalid number of compute nodes: ${num_compute_nodes}. Check your inventory file.${reset}"
325     exit 1
326   else
327     echo -e "${blue}INFO: Number of compute nodes set for deployment: ${num_compute_nodes}${reset}"
328     DEPLOY_OPTIONS+=" --compute-scale ${num_compute_nodes}"
329   fi
330
331   DEPLOY_OPTIONS+=" --ntp-server $ntp_server"
332
333   DEPLOY_OPTIONS+=" --control-flavor control --compute-flavor compute"
334   if [[ "$virtual" == "TRUE" ]]; then
335      DEPLOY_OPTIONS+=" -e virtual-environment.yaml"
336   fi
337
338   echo -e "${blue}INFO: Deploy options set:\n${DEPLOY_OPTIONS}${reset}"
339
340   ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
341 # Create a key for use by nova for live migration
342 echo "Creating nova SSH key for nova resize support"
343 ssh-keygen -f nova_id_rsa -b 1024 -P ""
344 public_key=\'\$(cat nova_id_rsa.pub | cut -d ' ' -f 2)\'
345 sed -i "s#replace_public_key:#key: \$public_key#g" ${ENV_FILE}
346 python -c 'open("opnfv-environment-new.yaml", "w").write((open("${ENV_FILE}").read().replace("replace_private_key:", "key: \"" + "".join(open("nova_id_rsa").readlines()).replace("\\n","\\\n") + "\"")))'
347 mv -f opnfv-environment-new.yaml ${ENV_FILE}
348
349 source stackrc
350 set -o errexit
351 # Workaround for APEX-207 where sometimes swift proxy is down
352 if ! sudo systemctl status openstack-swift-proxy > /dev/null; then
353   sudo systemctl restart openstack-swift-proxy
354 fi
355 echo "Uploading overcloud glance images"
356 openstack overcloud image upload
357
358 echo "Configuring undercloud and discovering nodes"
359 openstack baremetal import --json instackenv.json
360
361 if [[ -z "$virtual" ]]; then
362   openstack baremetal introspection bulk start
363   if [[ -n "$root_disk_list" ]]; then
364     openstack baremetal configure boot --root-device=${root_disk_list}
365   else
366     openstack baremetal configure boot
367   fi
368 else
369   openstack baremetal configure boot
370 fi
371
372 echo "Configuring flavors"
373 for flavor in baremetal control compute; do
374   echo -e "${blue}INFO: Updating flavor: \${flavor}${reset}"
375   if openstack flavor list | grep \${flavor}; then
376     openstack flavor delete \${flavor}
377   fi
378   openstack flavor create --id auto --ram 4096 --disk 39 --vcpus 1 \${flavor}
379   if ! openstack flavor list | grep \${flavor}; then
380     echo -e "${red}ERROR: Unable to create flavor \${flavor}${reset}"
381   fi
382 done
383 openstack flavor set --property "cpu_arch"="x86_64" --property "capabilities:boot_option"="local" baremetal
384 openstack flavor set --property "cpu_arch"="x86_64" --property "capabilities:boot_option"="local" --property "capabilities:profile"="control" control
385 openstack flavor set --property "cpu_arch"="x86_64" --property "capabilities:boot_option"="local" --property "capabilities:profile"="compute" compute
386 echo "Configuring nameserver on ctlplane network"
387 dns_server_ext=''
388 for dns_server in ${dns_servers}; do
389   dns_server_ext="\${dns_server_ext} --dns-nameserver \${dns_server}"
390 done
391 neutron subnet-update \$(neutron subnet-list | grep -Ev "id|tenant|external|storage" | grep -v \\\\-\\\\- | awk {'print \$2'}) \${dns_server_ext}
392 sed -i '/CloudDomain:/c\  CloudDomain: '${domain_name} ${ENV_FILE}
393 echo "Executing overcloud deployment, this should run for an extended period without output."
394 sleep 60 #wait for Hypervisor stats to check-in to nova
395 # save deploy command so it can be used for debugging
396 cat > deploy_command << EOF
397 openstack overcloud deploy --templates $DEPLOY_OPTIONS --timeout 90
398 EOF
399 EOI
400
401   if [ "$interactive" == "TRUE" ]; then
402     if ! prompt_user "Overcloud Deployment"; then
403       echo -e "${blue}INFO: User requests exit${reset}"
404       exit 0
405     fi
406   fi
407
408   ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
409 source stackrc
410 openstack overcloud deploy --templates $DEPLOY_OPTIONS --timeout 90
411 if ! openstack stack list | grep CREATE_COMPLETE 1>/dev/null; then
412   $(typeset -f debug_stack)
413   debug_stack
414   exit 1
415 fi
416 EOI
417
418   # Configure DPDK and restart ovs agent after bringing up br-phy
419   if [ "${deploy_options_array['dataplane']}" == 'ovs_dpdk' ]; then
420     ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI || (echo "DPDK config failed, exiting..."; exit 1)
421 source stackrc
422 set -o errexit
423 for node in \$(nova list | grep novacompute | grep -Eo "[0-9]+\.[0-9]+\.[0-9]+\.[0-9]+"); do
424 echo "Checking DPDK status and bringing up br-phy on \$node"
425 ssh -T ${SSH_OPTIONS[@]} "heat-admin@\$node" <<EOF
426 set -o errexit
427 sudo dpdk-devbind -s
428 sudo ifup br-phy
429 if [[ -z "${deploy_options_array['sdn_controller']}" || "${deploy_options_array['sdn_controller']}" == 'False' ]]; then
430   echo "Restarting openvswitch agent to pick up VXLAN tunneling"
431   sudo systemctl restart neutron-openvswitch-agent
432 fi
433 EOF
434 done
435 EOI
436   fi
437
438   if [ "$debug" == 'TRUE' ]; then
439       ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
440 source overcloudrc
441 echo "Keystone Endpoint List:"
442 openstack endpoint list
443 echo "Keystone Service List"
444 openstack service list
445 EOI
446   fi
447 }